package at.jku.students.heap;

import java.util.Arrays;
import java.util.Comparator;
import java.util.NoSuchElementException;

import at.jku.ssw.Iterator;
import at.jku.ssw.graphviz.DotMaker;
import at.jku.ssw.queue.PriorityQueue;

@SuppressWarnings({ "rawtypes", "unchecked" })
public class ArrayPriorityQueue extends PriorityQueue implements Cloneable {

	private final Comparator comparator;
	private Object[] values;
	private int count;

	public ArrayPriorityQueue(Comparator cmp) {
		comparator = cmp;
		values = new Object[1];
		count = 1;
	}

	private ArrayPriorityQueue(ArrayPriorityQueue other) {
		comparator = other.comparator;
		values = Arrays.copyOf(other.values, other.values.length);
		count = other.count;
	}

	/**
	 * Creates and returns a copy of this priority queue.
	 */
	@Override
	protected ArrayPriorityQueue clone() {
		return new ArrayPriorityQueue(this);
	}

	public String makeDot() {
		return DotMaker.makeDotForHeap(Arrays.copyOf(values, count));
	}

	@Override
	public String toString() {
		if (size() == 0) {
			return "[]";
		}
		StringBuilder sb = new StringBuilder();
		sb.append('[');

		Iterator it = iterator();
		assert it.hasNext();
		sb.append(it.next());

		while (it.hasNext()) {
			sb.append(", ");
			sb.append(it.next());
		}
		sb.append(']');
		return sb.toString();
	}

	/**
	 * Inserts the value into this priority queue.
	 *
	 * @throws IllegalArgumentException
	 *             if a <code>null</code> value is offered.
	 */
	@Override
	public void push(Object value) {
		// TODO
	}

	/**
	 * Retrieves and removes the head of this priority queue.
	 * 
	 * @throws NoSuchElementException
	 *             if the queue is empty
	 */
	@Override
	public Object take() {
		// TODO
		return null;
	}

	/**
	 * Retrieves the head of this priority queue without removing it.
	 * 
	 * @throws NoSuchElementException
	 *             if the queue is empty
	 */
	@Override
	public Object peek() {
		// TODO
		return null;
	}

	/**
	 * Returns <code>true</code> if this queue contains the specified value.
	 *
	 * @throws IllegalArgumentException
	 *             if the specified value is <code>null</code>.
	 */
	@Override
	public boolean contains(Object value) {
		// TODO
		return false;
	}

	/**
	 * Removes one instance of the specified object from this queue, if it is
	 * present. Returns <code>true</code> if and only if the queue contained the
	 * specified value (or in other words, if this queue changed as a result of
	 * the call).
	 *
	 * @throws IllegalArgumentException
	 *             if the specified value is <code>null</code>.
	 */
	@Override
	public boolean remove(Object value) {
		// TODO
		return false;
	}

	/**
	 * Returns the number of values in this priority queue.
	 */
	@Override
	public int size() {
		// TODO
		return -1;
	}

	/**
	 * Returns an iterator of the values in this priority queue. The iterator
	 * returns the values in sorted order, from the value with the highest
	 * priority to the value with the lowest priority.
	 */
	@Override
	public Iterator iterator() {
		// TODO
		return null;
	}
}
